
#include <stdio.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

// int semget(key_t key, int nsems, int semflg);

main(int argc, char **argv) 
{
   int num_figli = atoi(argv[1]);
   int i, semSincro;
   pid_t padre;
   struct sembuf waitzero, decr;

   /* operazione di attesa dello zero */
   waitzero.sem_num = 0;
   waitzero.sem_op  = 0;
   waitzero.sem_flg = 0;

   /* operazione di down */
   decr.sem_num = 0;
   decr.sem_op  = -1;
   decr.sem_flg = 0;

   semSincro = semget(IPC_PRIVATE, 1, 0666);
   semctl(semSincro, 0, SETVAL, atoi(argv[1]));
   printf("\n DEBUG semid = %d\n", semSincro);

   if (semSincro < 0) {
	   fprintf(stderr, "\n non ho potuto allocare il semaforo ... termino\n");
	   exit(0);
   }

   for (i=0; i<num_figli; i++) {
       padre = fork();

       if (padre<0) {
	       fprintf(stderr, "generazione figlio fallita ... termino \n");
	       exit(-1);
       }
       else if (!padre) {
	       // mi sospendo
	       // quando siamo stati creati tutti
	       // // ci risvegliamo, facciamo una stampa e terminiamo
	       fprintf(stderr,"\n figlio %d, prima di semop", getpid()); fflush(stderr);
	       semop(semSincro, &waitzero, 1);
	       fprintf(stderr,"\n figlio %d, muoio", getpid()); fflush(stderr);
	       exit(0);
       }
   }

   if (padre) sleep(3);

   for (i=0; i<num_figli; i++) semop(semSincro, &decr, 1);

   for (i=0; i<num_figli; i++) wait(0);
   semctl(semSincro, 0, IPC_RMID, 0);

}
